Name: MySQL
Version: 5.0.51
Release: alt2.a.M40.1

%def_without debug
%def_disable static
%def_with    openssl
%define mysql_version %version
%define mysqld_user mysql
%define _libexecdir %_sbindir
%define ROOT %_localstatedir/mysql

Summary: MySQL: A very fast and reliable SQL database engine
Summary(ru_RU.KOI8-R): MySQL:     SQL-
Group: Databases
License: GPL / LGPL
Url: http://www.mysql.com/
Packager: MySQL Development Team <mysql@packages.altlinux.org>

Source: ftp://ftp.mysql.com/pub/mysql/src/mysql-%mysql_version.tar
Source1: mysqld.init
Source2: mysql.logrotate
Source3: safe_mysqld
Source4: mysqld_wrapper
Source5: my.cnf
Source6: mysql.chroot.lib
Source7: mysql.chroot.conf
Source8: mysql.chroot.all
Source9: mysql_migrate
Source10: mysqld.sysconfig
Source11: http://downloads.mysql.com/docs/refman-5.0-en.html-chapter.tar.gz
Source12: mysql_fix_username_length.sql.in
Source13: mysql_fix_username_length.sh
Source14: README.ALT-ru_RU.KOI8-R

# ALTLinux
Patch1: mysql-5.0.18-alt-chroot.patch
#Patch2: mysql-4.0.15-alt-convert.patch
Patch3: mysql-3.23.55-alt-configure.patch
Patch4: mysql-4.0.15-alt-fix-internal-db.patch
#Patch5: mysql-3.23.42-alt-texinfo.patch
Patch6: mysql-4.0.15-alt-client.patch
#Patch7: mysql-4.0.24-alt-docs-html-split.patch
Patch8: mysql-5.0.18-alt-load_defaults.patch
#Patch9: mysql-5.0.18-alt-tinfo.patch
Patch10: mysql-5.0.51-alt-mysql_install_db.patch
Patch11: mysql-5.0.18-alt-hack-non-static.patch
Patch22: mysql-5.0.20-alt-libdir.patch
# variable username length 
Patch23: mysql-5.0.51-alt-username-length.patch

# Annvix/Mandriva
Patch14: db-4.1.24-amd64-mutexes.patch
Patch15: db-4.1.24-disable-pthreadsmutexes.patch
Patch16: mysql-5.0.15-disable-pthreadsmutexes.patch

# Redhat
Patch20: mysql-5.0.21-rh-no-atomic.patch
#Patch21: mysql-5.0.16-rh-libtool.patch

# BK commits

%{?_with_openssl:BuildPreReq: libssl-devel}

# Automatically added by buildreq on Wed Sep 17 2003
BuildRequires: gcc-c++ libncurses-devel libreadline-devel libstdc++-devel libtinfo-devel zlib-devel perl-DBI perl-CGI

%package -n libMySQL
Summary: MySQL: Shared libraries
Summary(ru_RU.KOI8-R): MySQL:  
License: LGPL
Group: System/Libraries
Provides: MySQL-shared = %version, mysql-shared = %version
Obsoletes: MySQL-shared-libs, MySQL-shared, mysql-shared

%package -n libMySQL-devel
Summary: MySQL: Development header files and libraries
Summary(ru_RU.KOI8-R): MySQL:      
License: LGPL
Group: Development/C
Provides: MySQL-devel = %version, mysql-devel = %version
Obsoletes: MySQL-devel, mysql-devel
Requires: libMySQL = %version-%release
%{?_with_openssl:Requires: libssl-devel}

%package -n libMySQL-devel-static
Summary: MySQL: Development static libraries
Summary(ru_RU.KOI8-R): MySQL:      
License: LGPL
Group: Development/C
Provides: MySQL-devel = %version, mysql-devel-static = %version
Requires: libMySQL-devel = %version-%release
%{?_with_openssl:Requires: libssl-devel-static}

%package client
Summary: MySQL: Client
Summary(ru_RU.KOI8-R): MySQL: 
License: GPL
Group: Databases
Provides: mysql-client = %version
Obsoletes: mysql-client
Requires(post): %install_info
Requires(preun): %uninstall_info
Requires: libMySQL = %version-%release
AutoReq: yes, noperl

%package server
Summary: MySQL: A very fast and reliable SQL database engine
Summary(ru_RU.KOI8-R): MySQL:     SQL-
License: GPL
Group: Databases
Provides: MySQL = %version, mysql-server = %version, mysql, msqlormysql, mysqlserver
Obsoletes: MySQL, mysql, mysql-server, msqlormysql, mysqlserver, MySQL-doc
PreReq: shadow-utils, coreutils, glibc-locales
Requires(post,preun): chkconfig, chrooted, coreutils, findutils, grep, sed, %__subst
PreReq: libMySQL = %version-%release, MySQL-client = %version-%release

%package server-perl
Summary: MySQL: Perl utils for MySQL-server
License: GPL
Group: Databases
Requires: perl-DBD-mysql, perl-CGI, MySQL-server = %version-%release

%package bench
Summary: MySQL: Benchmarks
Summary(ru_RU.KOI8-R): MySQL:  
License: GPL
Group: Databases
Provides: mysql-bench = %version
Obsoletes: mysql-bench
Requires: MySQL-client = %version-%release, perl-DBD-mysql

%package htmlhelp
Summary: html documentation for MySQL 5.0
Group: System/Servers

%define see_base For a description of MySQL see the base MySQL RPM or %url
%define see_base_ru      MySQL   %url

%description
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a server daemon (mysqld) and many different client
programs/libraries.

The main goals of MySQL are speed, robustness and ease of use.  MySQL
was originally developed because we needed a SQL server that could
handle very big databases with magnitude higher speed than what any
database vendor could offer to us. And since we did not need all the
features that made their server slow we made our own. We have now been
using MySQL since 1996 in a environment with more than 40 databases,
10,000 tables, of which more than 500 have more than 7 million
rows. This is about 200G of data.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many
years. While MySQL is still in development, it already offers a rich
and highly useful function set.

This version allows to use transactions with BDB tables and extended
character set support. See the documentation for more information

%description -l ru_RU.KOI8-R
MySQL -  ,  SQL- (SQL -
  )  . MySQL   
/      mysqld    
   .

 MySQL - ,    . 
MySQL     ,   
       .  
,  MySQL  ,      
  .

  MySQL       
  . .     .

%description server
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a server daemon (mysqld) and many different client
programs/libraries.

The main goals of MySQL are speed, robustness and ease of use.  MySQL
was originally developed because we needed a SQL server that could
handle very big databases with magnitude higher speed than what any
database vendor could offer to us. And since we did not need all the
features that made their server slow we made our own. We have now been
using MySQL since 1996 in a environment with more than 40 databases,
10,000 tables, of which more than 500 have more than 7 million
rows. This is about 200G of data.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many
years. While MySQL is still in development, it already offers a rich
and highly useful function set.

This version allows to use transactions with BDB tables and extended
character set support. See the documentation for more information.

By default, MySQL server runs in safe chrooted environment with own uid and gid.

%description server-perl
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a server daemon (mysqld) and many different client
programs/libraries.
This package contents perl utils for MySQL-server.

%description server -l ru_RU.KOI8-R
MySQL -  ,  SQL- (SQL -
  )  . MySQL   
/      mysqld    
   .

 MySQL - ,    . 
MySQL     ,   
       .  
,  MySQL  ,      
  .

  MySQL       
  . .     .

%description -n libMySQL
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.

%description -n libMySQL -l ru_RU.KOI8-R
      ( *.so*),
     , 
 SQL- MySQL.

%description -n libMySQL-devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

%see_base

%description -n libMySQL-devel -l ru_RU.KOI8-R
       
 ,    
,   SQL- MySQL.

%see_base_ru

%description -n libMySQL-devel-static
This package contains the development libraries for static linking
necessary to develop MySQL client applications.

%see_base

%description -n libMySQL-devel-static -l ru_RU.KOI8-R
       ,
    ,
  SQL- MySQL.

%see_base_ru

%description client
This package contains the standard MySQL clients.

%see_base

%description client -l ru_RU.KOI8-R
       SQL- MySQL

%see_base_ru

%description bench
This package contains MySQL benchmark scripts and data.

%see_base

%description bench -l ru_RU.KOI8-R
       
 SQL- MySQL.

%description htmlhelp
The offline version of the recent MySQL 5.0 html manual from
http://dev.mysql.com/doc/

%description htmlhelp -l ru_RU.KOI8-R
 html   MySQL 5.0   http://dev.mysql.com/doc/

%see_base_ru

%prep
%setup -q -n mysql-%mysql_version -a11
%patch1 -p1
#patch2
%patch3 -p1
#patch4 -p1 <-TODO
#patch5 -p1
%patch6 -p1
#patch7 -p1
%patch8 -p1
#patch9 -p1
%patch10 -p2
#patch11 -p1
%patch20 -p1
#patch21 -p1
%ifarch x86_64
%patch14 -p1
%patch22 -p1
%endif # x86_64
%patch15 -p1
%patch16 -p0
%patch23 -p2 -b .username-length
cp -a %SOURCE12 %SOURCE13 scripts/

# put html docs in place
mv html-chapter Docs/html
   
# Use local regex.h header.
find -type f -print0 |
	xargs -r0 %__grep -FZl '<regex.h>' -- |
	xargs -r0 %__subst 's,<regex\.h>,"../regex/regex.h",g' --

# Prepare commands list for completion in mysql client.
sed -ne 's/^\(  { "[A-Z][^"]*"\).*/\1, 0, 0, 0, "" },/pg' <sql/lex.h >client/mysql_symbols.inc

find -type d -name CVS -print0 |
	xargs -r0 %__rm -rf --
find -type f -name .cvsignore -print0 |
	xargs -r0 %__rm -f --

chmod -R a-s,go-w sql-bench

%build

# Force HAVE_ERRNO_AS_DEFINE defined to wrong expansion
# of bits/errno.h's definition of errno in my_sys.h
%{!?_with_debug:%add_optflags %optflags_notraceback}
%add_optflags -D_FILE_OFFSET_BITS=64 -DHAVE_ERRNO_AS_DEFINE -DONE_THREAD
export CXXFLAGS="$RPM_OPT_FLAGS -felide-constructors -fno-exceptions -fno-rtti"

autoreconf -fisv

# Precache these values to enable /proc-less build.
export \
	FIND_PROC='/bin/ps p $$PID | grep mysqld >/dev/null' \
	CHECK_PID='/bin/kill -0 $$PID >/dev/null 2>/dev/null' \
	#

%configure \
	--localstatedir=%ROOT \
	--enable-assembler \
	--enable-shared \
	--enable-thread-safe-client \
	--without-readline \
	--without-mysqlfs \
	--enable-largefile=yes \
	--enable-large-files=yes \
	--with-archive-storage-engine \
	--with-blackhole-storage-engine \
	--without-example-storage-engine \
	%{subst_with debug} \
	%{subst_enable static} \
	--with-raid \
	--with-berkeley-db \
	--with-big-tables \
	--with-isam \
	--with-extra-charsets=all \
	--with-mysqld-user=%mysqld_user \
	--with-unix-socket-path=%ROOT/mysql.sock \
	--with-comment="%distribution MySQL RPM" \
	--with-username-length=32 \
%if_with openssl
	--with-openssl
%else
	--without-openssl
%endif

# Use g++ for linking.
%__subst 's,^CCLD = \$(CC),CCLD = $(CXX),g' *isam/Makefile*

pushd bdb/build_unix
	%__rm -f config.cache
	../dist/configure --prefix=%prefix
popd

# Benchdir does not fit in above model. Maybe a separate bench distribution
%make_build benchdir=$RPM_BUILD_ROOT%_datadir/sql-bench

%install
%__mkdir_p $RPM_BUILD_ROOT{%_bindir,%_sbindir,%_libdir,%_includedir,%_mandir,%_infodir,%_datadir/sql-bench,/var/log/mysql}
%__mkdir_p $RPM_BUILD_ROOT%ROOT/{etc,lib,log,tmp,/var/{nis,yp/binding},db/mysql,usr/share/mysql/charsets}
touch $RPM_BUILD_ROOT%ROOT{%_sysconfdir/{hosts,services,{host,nsswitch,resolv}.conf},/var/nis/NIS_COLD_START}

%make_install install DESTDIR=$RPM_BUILD_ROOT \
	localstatedir=$RPM_BUILD_ROOT%ROOT/db \
	benchdir=%_datadir/sql-bench

# Relocate mysql_install_db
%__mv $RPM_BUILD_ROOT%_bindir/mysql_install_db $RPM_BUILD_ROOT%_sbindir/

# Relocate libmysqlclient* libraries.
%__mv $RPM_BUILD_ROOT%_libdir/mysql/libmysqlclient* $RPM_BUILD_ROOT%_libdir/

# Install various helper scripts.
%__install -pD -m755 %SOURCE1 $RPM_BUILD_ROOT%_initdir/mysqld
%__install -pD -m644 %SOURCE2 $RPM_BUILD_ROOT%_sysconfdir/logrotate.d/mysql
%__install -pD -m755 %SOURCE3 $RPM_BUILD_ROOT%_sbindir/safe_mysqld
%__install -pD -m755 %SOURCE4 $RPM_BUILD_ROOT%_sbindir/mysqld_wrapper
%__install -pD -m750 %SOURCE6 $RPM_BUILD_ROOT%_sysconfdir/chroot.d/mysql.lib
%__install -pD -m750 %SOURCE7 $RPM_BUILD_ROOT%_sysconfdir/chroot.d/mysql.conf
%__install -pD -m750 %SOURCE8 $RPM_BUILD_ROOT%_sysconfdir/chroot.d/mysql.all
%__install -pD -m750 %SOURCE9 $RPM_BUILD_ROOT%_sbindir/mysql_migrate
%__install -pD -m644 %SOURCE10 $RPM_BUILD_ROOT%_sysconfdir/sysconfig/mysqld

# Make backwards compatibility links (ALT #14863)
mkdir -p $RPM_BUILD_ROOT%_bindir
ln -snf ../sbin/safe_mysqld $RPM_BUILD_ROOT%_bindir/mysqld_safe

# Install configuration files.
%__install -pD -m644 /dev/null $RPM_BUILD_ROOT%_sysconfdir/my.cnf
%__install -pD -m600 %SOURCE5 $RPM_BUILD_ROOT%ROOT/my.cnf

# FIXME! bdb maybe work on x86/Linux and amd64/Linux
%ifarch %ix86
%__subst 's,^skip\-bdb,#skip-bdb,' $RPM_BUILD_ROOT%ROOT/my.cnf
%endif

%__install -pD -m644 $RPM_BUILD_ROOT%_datadir/mysql/charsets/* \
		     $RPM_BUILD_ROOT%ROOT%_datadir/mysql/charsets

# Fix \r.
r="$(echo -ne \\r)"
%__grep -lZ "$r\$" $RPM_BUILD_ROOT%_datadir/sql-bench/innotest* |
	xargs -r0 %__subst "s/$r//g" --

# Fixed perl autodetection.
%__grep -EZl '^[[:space:]]*use the ' $RPM_BUILD_ROOT%_bindir/* |
	xargs -r0 %__subst -p 's/\([[:space:]]*\)\(use the \)/\1then \2/g'
	
# Install texinfo documentation.
%__install -m644 Docs/*.info* $RPM_BUILD_ROOT%_infodir/

%__subst -p 's/\(BUGmysql="\)\([^"]*\)"/\1\2,mysql@packages.altlinux.org"/g' $RPM_BUILD_ROOT%_bindir/mysqlbug

%__mkdir_p $RPM_BUILD_ROOT%_docdir/MySQL-%version
%__install -p -m644 README %SOURCE14 support-files/*.cnf $RPM_BUILD_ROOT%_docdir/MySQL-%version
%if_with openssl
%__cp -a SSL $RPM_BUILD_ROOT%_docdir/MySQL-%version
%endif

%__rm -f $RPM_BUILD_ROOT%_bindir/safe_mysqld
%__rm -f $RPM_BUILD_ROOT%_datadir/mysql/mysql{-*.spec,-log-rotate,.server}

%__install -p -m644 ChangeLog $RPM_BUILD_ROOT%_docdir/MySQL-%version/
bzip2 -f9 $RPM_BUILD_ROOT%_docdir/MySQL-%version/ChangeLog

touch $RPM_BUILD_ROOT%ROOT/log/queries
touch $RPM_BUILD_ROOT/var/log/mysql/info

%post -n libMySQL -p %post_ldconfig
%postun -n libMySQL -p %postun_ldconfig

%pre server
/usr/sbin/groupadd -r -f %mysqld_user
/usr/sbin/useradd -r -g %mysqld_user -d %ROOT -s /dev/null -c "MySQL server" -n %mysqld_user >/dev/null 2>&1 ||:

if [ ! -e %ROOT/my.cnf -a -f /etc/my.cnf -a ! -L /etc/my.cnf -a ! -e /etc/my.cnf.rename ]; then
	%__mv -v /etc/my.cnf /etc/my.cnf.rename &&
	chown 0:0 /etc/my.cnf.rename &&
	chmod 600 /etc/my.cnf.rename ||
	{ echo "Error moving my.cnf" >&2; exit 1; }
fi

%post server
if [ -f /etc/my.cnf.rename -a ! -L /etc/my.cnf.rename -a ! -e /etc/my.cnf ]; then
	%__mv -fv %ROOT/my.cnf %ROOT/my.cnf.rpmnew &&
	%__mv -v /etc/my.cnf.rename %ROOT/my.cnf &&
	chown 0:0 %ROOT/my.cnf &&
	chmod 600 %ROOT/my.cnf ||
	{ echo "Error moving my.cnf" >&2; %__mv -v /etc/my.cnf.rename /etc/my.cnf; }
fi

%install_info mysql.info
    %_sysconfdir/chroot.d/mysql.all force
    %__rm -rf %ROOT/dev

%post_service mysqld       
DATADIR=`/usr/bin/my_print_defaults mysqld |sed -ne 's/^--datadir=\(.*\)/\1/pg' |tail -1`
[ -n "$DATADIR" ] || { echo "Failed to read configuration"; exit 1; }

if [ "$DATADIR" = / ]; then
	# Have to update configuration manually.
	%__subst 's,^datadir=/$,datadir=/db,g' /etc/my.cnf &&
		DATADIR=`/usr/bin/my_print_defaults mysqld |%__sed -ne 's/^--datadir=\(.*\)/\1/pg' |tail -1` ||
		{ echo "Failed to update configuration"; exit 1; }
fi

NEED_RESTART=
if [ -f "%ROOT/mysql/db.frm" -a ! -f "%ROOT$DATADIR/mysql/db.frm" ]; then
	%_initdir/mysqld status &>/dev/null && %_initdir/mysqld stop && NEED_RESTART=1 ||:
	(cd %ROOT
	%__install -d -m750 -o %mysqld_user -g adm ".$DATADIR"
	for d in `find -mindepth 1 -maxdepth 1 -type d |%__grep -Ev '\./(dev|etc|lib|log|tmp|db)$'`; do
		%__mv -i "$d" ".$DATADIR/$d"
	done)
	echo "Database root have been moved to $DATADIR"
fi

if [ -n "$NEED_RESTART" ]; then
	%_initdir/mysqld start ||:
else
	%_initdir/mysqld condrestart ||:
fi

%triggerpostun server -- MySQL-server < 5.0
DATADIR=`/usr/bin/my_print_defaults mysqld |sed -ne 's/^--datadir=\(.*\)/\1/pg' |tail -1`
[ -n "$DATADIR" ] || { echo "Failed to read configuration"; exit 1; }

[ -x /usr/bin/mysql_upgrade ] || exit 0
if [ -f "%ROOT/mysql/db.frm" -a ! -f "%ROOT$DATADIR/mysql/db.frm" ]; then
	%_initdir/mysqld status >/dev/null 2>&1 && NEED_RESTART=1 || NEED_RESTART=
	/usr/bin/mysql_upgrade --datadir=%ROOT$DATADIR >/dev/null 2>&1
fi

if [ -n "$NEED_RESTART" ]; then 
	%_initdir/mysqld condrestart ||:
else
	echo "mysqld service is not running so you should run " 
	echo "/usr/bin/mysql_upgrade --datadir=%ROOT$DATADIR manually "
	echo "after service mysql start!"
	%_initdir/mysqld condrestart ||:
fi

%triggerpostun server -- MySQL-server <= 5.0.24-alt2
echo "Please run mysql_fix_username_length script if you" 
echo "want use db usernames longer than char(16)!  "
echo "See README.ALT-ru_RU.KOI8-R for additional details."

%preun server
%preun_service mysqld

%postun server
if [ $1 = 0 ]; then
	%__rm -f %ROOT/lib/* %ROOT/var/yp/binding/*
fi

%post client
%install_info mysql.info

%preun client
%uninstall_info mysql.info

%files -n libMySQL
%_libdir/*.so.*

%files -n libMySQL-devel
%_bindir/mysql_config
%_bindir/comp_err
%_libdir/*.so
%_includedir/*

%if_enabled static
%files -n libMySQL-devel-static
%_libdir/*.a
%_libdir/mysql
%endif #static 

%files client
%_bindir/innochecksum
%_bindir/msql2mysql
%_bindir/my_print_defaults
%_bindir/mysql
%_bindir/mysql_client_test
%_bindir/mysql_explain_log
%_bindir/mysql_tableinfo
%_bindir/mysqladmin
%_bindir/mysqlbinlog
%_bindir/mysqlbug
%_bindir/mysqlcheck
%_bindir/mysqldump
%_bindir/mysqlimport
%_bindir/mysqlshow
%_bindir/mysqltest
%_bindir/perror
%_bindir/replace
%_bindir/resolve*
%_mandir/man?/*
%_infodir/*.info*

%files server-perl
%_bindir/mysql_convert_table_format
%_bindir/mysql_find_rows
%_bindir/mysql_setpermission
%_bindir/mysql_zap
%_bindir/mysqlhotcopy
%_bindir/mysqlaccess
%_bindir/mysqldumpslow

%files server
%_initdir/*
%config(noreplace) %_sysconfdir/sysconfig/*
%config(noreplace) %_sysconfdir/logrotate.d/*
%config %_sysconfdir/chroot.d/*
%ghost %config(noreplace,missingok) %_sysconfdir/my.cnf
%_bindir/*isam*
%_bindir/mysql_fix_extensions
%_bindir/mysql_fix_privilege_tables
%_bindir/mysql_fix_username_length
%_bindir/mysql_secure_installation
%_bindir/mysql_tzinfo_to_sql
%_bindir/mysql_upgrade
%_bindir/mysql_upgrade_shell
%_bindir/mysqld_multi
%_bindir/mysqld_safe
%_sbindir/*
%_datadir/mysql
%attr(750,root,adm) %dir /var/log/mysql
%ghost %verify(not md5 mtime size) /var/log/mysql/*
%dir %_docdir/MySQL-%version
%_docdir/MySQL-%version/ChangeLog*
%_docdir/MySQL-%version/README
%_docdir/MySQL-%version/README.*
%_docdir/MySQL-%version/*.cnf
%if_with openssl
%dir %_docdir/MySQL-%version/SSL
%_docdir/MySQL-%version/SSL/NOTES
%_docdir/MySQL-%version/SSL/run*
%endif
%attr(600,root,root) %config(noreplace,missingok) %ROOT/my.cnf
%attr(3771,root,mysql) %dir %ROOT
%attr(710,root,mysql) %dir %ROOT/lib
%attr(710,root,mysql) %dir %ROOT%_sysconfdir
%ghost %ROOT%_sysconfdir/hosts
%ghost %ROOT%_sysconfdir/services
%ghost %ROOT%_sysconfdir/*.conf
%attr(710,root,mysql) %dir %ROOT/var
%dir %ROOT/var/nis
%ghost %ROOT/var/nis/NIS_COLD_START
%dir %ROOT/var/yp
%dir %ROOT/var/yp/binding
%dir %ROOT/usr
%dir %ROOT%_datadir
%ROOT%_datadir/mysql
%attr(3770,root,mysql) %dir %ROOT/db
%attr(750,mysql,mysql) %dir %ROOT/db/*
%attr(3770,root,mysql) %dir %ROOT/log
%attr(660,mysql,mysql) %ghost %verify(not md5 mtime size) %ROOT/log/*
%attr(3770,root,mysql) %dir %ROOT/tmp

%files bench
%_datadir/sql-bench

%files htmlhelp
%doc Docs/html

%changelog
* Sat May 31 2008 Dmitry V. Levin <ldv@altlinux.org> 5.0.51-alt2.a.M40.1
- Fixed build for 4.0 branch.

* Sun Mar 16 2008 L.A. Kostis <lakostis@altlinux.ru> 5.0.51-alt2.a
- 5.0.51a.
- Security fixes:
  + CVE-2008-0226, CVE-2008-0227 (Three vulnerabilities in yaSSL versions 1.7.5
    that could lead to a server crash or execution of unauthorized code.)
  + ALTER VIEW retained the original DEFINER value, even when altered by
    another user, which could allow that user to gain the access rights of the
    view (MySQL #29908).
- Add glibc-locales to -server deps (ALT #13909 #14731).
- Make links to mysqld_safe for backwards compatibility (ALT #14863).
- Update html documentation to 10265 revsion.

* Tue Jan 01 2008 L.A. Kostis <lakostis@altlinux.ru> 5.0.51-alt1
- 5.0.51.
- Security fixes:
  + CVE-2007-5969 (RENAME TABLE System Table Overwrite Vulnerability)
  + CVE-2007-6303 CVE-2007-6304 
    (Server Privilege Escalation And Denial Of Service Vulnerabilities) 
- Update html documentation to 9232 revision.

* Thu Aug 09 2007 L.A. Kostis <lakostis@altlinux.ru> 5.0.46-alt2
- fix a typo in alt-mysql_install_db.patch.

* Mon Aug 06 2007 L.A. Kostis <lakostis@altlinux.ru> 5.0.46-alt1
- 5.0.46.
- Update -alt-install-db.patch.
- Update -alt-username-length patch.
- Update documentation to 7319 revision.

* Wed Jun 20 2007 L.A. Kostis <lakostis@altlinux.ru> 5.0.42-alt1
- 5.0.42.

* Mon May 28 2007 L.A. Kostis <lakostis@altlinux.ru> 5.0.41-alt1
- 5.0.41 release.
- Fix CVE-2007-2583 DoS (Failure to Handle Exceptional Conditions).
- Added patches from BK:
  + BUG#28337 (NOT EXISTS with GROUP BY behaves different in 5.0.40).
- Update ALTLinux patches:
  + install-db patch.
  + username-length patch.
- Updated html help (to 6552 revision).
- Allow custom nice setting for mysqld (fix ALT #10941).
- Added mysqld-multi (fix ALT #5715).
- Added several files for -server and client.

* Sun Feb 11 2007 L.A. Kostis <lakostis@altlinux.ru> 5.0.34-alt1
- 5.0.34 release.
- update html help (to 4891 revision).
- Fix db_install in hasher (closes #10788).
- Fix charset detection routes in init.d script.
- Update install-db patch.
- Remove obsoleted patches.

* Sat Dec 30 2006 L.A. Kostis <lakostis@altlinux.ru> 5.0.30-alt0.1
- Unofficial 5.0.30 release (use Debian sources).
- Use Docs from previous 5.0.27-GA release.
- Fix SSL docs install.

* Fri Dec 29 2006 ALT QA Team Robot <qa-robot@altlinux.org> 5.0.27-alt1.1
- Rebuilt due to libcrypto.so.4 -> libcrypto.so.6 soname change.

* Thu Nov 02 2006 L.A. Kostis <lakostis@altlinux.ru> 5.0.27-alt1
- 5.0.27 release;
- Added patches:
  + db-4.1.24-disable-pthreadsmutexes.patch: fix NPTL issues 
    (found in Mandriva package); 
  + mysql-5.0.15-disable-pthreadsmutexes.patch: fix NPTL issues 
    (found in Mandriva package);
  + mysql-5.0.27-alt-username-length.patch: add custom username-length 
    (5.0 backport of BUG#16553) and README.ALT-ru_RU.KOI8-R about incompatible
    changes introduced by this patch;
- Add html documentation from http://dev.mysql.com/docs.

* Sat Aug 26 2006 LAKostis <lakostis at altlinux.org> 5.0.24-alt2
- fix libmysqlclient ABI breakage introduced in 5.0.24 (see
  http://bugs.mysql.com/bug.php?id=21543 for details).

* Wed Aug 09 2006 LAKostis <lakostis at altlinux.org> 5.0.24-alt1
- 5.0.24 release. 

* Thu Jun 01 2006 LAKostis <lakostis at altlinux.ru> 5.0.22-alt1
- 5.0.22.
- Security fix of SQL-injection multibyte encoding processing.

* Wed May 10 2006 LAKostis <lakostis at altlinux.ru> 5.0.21-alt1
- 5.0.21.
- Remove bk patches (merged to upstream).
- Update install_db patch.
- Update -no-atomic patch.
- Remove tinfo patch (http://bugs.mysql.com/bug.php?id=18912).
- Security fixes:
  + CVE-2006-1516;
  + CVE-2006-1517;
  + CVE-2006-1518.

* Fri Apr 14 2006 LAKostis <lakostis at altlinux.ru> 5.0.20-alt1
- 5.0.20.
- Add mysql_upgrade trigger/script for proper 4.x -> 5.0 upgrade.
- Added some fixing patches from upcoming 5.0.21:
  + BUG#16281 (Multi-table update failing to change matched rows).
  + BUG#18830 (incompatibility new libraries with old server).
- Removed obsoleted patches.

* Sun Apr 09 2006 LAKostis <lakostis at altlinux.ru> 5.0.18-alt2
- Added patches:
  + BUG#15719 fix (see #9348 for details);
  + BUG#17667 (aka CVE-2006-0903) fix;
  
* Thu Feb 23 2006 LAKostis <lakostis at altlinux.ru> 5.0.18-alt1.4
- fix #9135;
- fix debug switch.
- fix non-static build switch.

* Sun Feb 12 2006 LAKostis <lakostis at altlinux.ru> 5.0.18-alt1.3
- fix bogus vars in init.d script.
- add skip-bdb only for x86_64.

* Tue Feb 07 2006 LAKostis <lakostis at altlinux.ru> 5.0.18-alt1.2
- fix alt-chroot patch.
- fix init.d script and add /etc/sysconfig/mysqld entry.

* Sun Feb 05 2006 LAKostis <lakostis at altlinux.ru> 5.0.18-alt1.1
- remove chroot patch. Need to rework!
- disable ssl support.
- fix ssl switch.

* Wed Feb 01 2006 LAKostis <lakostis at altlinux.ru> 5.0.18-alt1
- release for Sisyphus;
- cleanup patches.

* Thu Jan 26 2006 LAKostis <lakostis at altlinux.ru> 5.0.18-alt0.1
- jump to 5.0.18.
- update patches from Fedora.
- update create_db patch.
- update defaults patch, add DATADIR to config_search path.
- add old_passwords=1 for compatibility with old clients.
- disable log queries by default.
- disable bdb support (for AMD64/x86 see comment in my.cnf).
- disable -static builds by default.

* Tue Jan 17 2006 LAKostis <lakostis at altlinux.ru> 4.1.16-alt0.1
- 4.1.16.

* Sun Dec 25 2005 LAKostis <lakostis at altlinux.ru> 4.1.14-alt0.5
- remove chroot build switch.

* Sun Nov 20 2005 LAKostis <lakostis at altlinux.ru> 4.1.14-alt0.4
- fix chroot config handling.

* Sat Sep 17 2005 LAKostis <lakostis at altlinux.ru> 4.1.14-alt0.3
- 4.1.14;
- FIXME - need rework chroot patch for proper charset handling; 
- add isam support for old db installs.
- add x86_64 patches from RH and Annvix;
- add non-chroot build switch;
- remove doc package.

* Thu Mar 24 2005 Kachalov Anton <mouse@altlinux.ru> 4.0.24-alt1
- 4.0.24

* Wed Oct 20 2004 Kachalov Anton <mouse@altlinux.ru> 4.0.21-alt1
- 4.0.21
- don't kill other mysqld processes on service stop (#5371)

* Mon Jun 07 2004 Kachalov Anton <mouse@altlinux.ru> 4.0.20-alt1
- new version 4.0.20
- Added script mysqlhotcopy (#3365)
- Merge -utils package with -server-perl
- fixed mysqld.init script (3rd time :)

* Wed Apr 28 2004 Kachalov Anton <mouse@altlinux.ru> 4.0.18-alt4
- Move mysqlaccess and mysqldumpslow scripts to new MySQL-utils package (#3964)

* Wed Mar 17 2004 Kachalov Anton <mouse@altlinux.ru> 4.0.18-alt3
- Added requires for MySQL-client for perl-CGI (#2359)

* Fri Feb 27 2004 Kachalov Anton <mouse@altlinux.ru> 4.0.18-alt2
- MySQL server crashes while running on systems with LDAP (#3729)

* Wed Feb 18 2004 Kachalov Anton <mouse@altlinux.ru> 4.0.18-alt1
- new version 4.0.18
- fixed mysqld.init script (Dmitry Vukolov <dav@altlinux.org>)

* Thu Dec 18 2003 Kachalov Anton <mouse@altlinux.ru> 4.0.17-alt1
- new version 4.0.17

* Fri Nov 28 2003 Kachalov Anton <mouse@altlinux.ru> 4.0.16-alt2
- fixed setting of default charset
- removed depreciated buildreqs

* Tue Nov 25 2003 Kachalov Anton <mouse@altlinux.ru> 4.0.16-alt1
- new version 4.0.16
- fixed Requires(post,preun) (#3155)
- Do not package .la files.

* Tue Sep 30 2003 Kachalov Anton <mouse@altlinux.ru> 4.0.15-alt2
- added mysql_migrate script for migration from 3.x to 4.0 version of MySQL
- mysql_install_db script fix (based on old ldv's script)

* Wed Sep 17 2003 Kachalov Anton <mouse@altlinux.ru> 4.0.15-alt1
- new version 4.0.15
- enabled charset conversion for more charsets

* Thu Jul 10 2003 Kachalov Anton <mouse@altlinux.ru> 4.0.13-alt1
- new version 4.0.13

* Fri Mar 21 2003 Dmitry V. Levin <ldv@altlinux.org> 3.23.56-alt3
- Fixed my.cnf migration support.

* Tue Mar 18 2003 Dmitry V. Levin <ldv@altlinux.org> 3.23.56-alt2
- Fixed build in environment without /proc.
- Fixed build without libncurses-devel.
- Updated buildrequires.
- server: handle default my.cnf migration.

* Tue Mar 18 2003 Dmitry V. Levin <ldv@altlinux.org> 3.23.56-alt1
- Updated to 3.23.56, redone few patches.

* Tue Mar 11 2003 Dmitry V. Levin <ldv@altlinux.org> 3.23.55-alt3
- load_defaults: do not process untrusted files if executed by root.

* Mon Mar 10 2003 Dmitry V. Levin <ldv@altlinux.org> 3.23.55-alt2
- Packaged %ROOT/my.cnf, owned by root and available to root only,
  to avoid mysql->root possible privilege escalation described by
  Gufino in his Bugtraq posting:
  http://www.securityfocus.com/archive/1/314391
- Changed /etc/my.cnf permissions from 0600 to 0644.
  Check your /etc/my.cnf file and move all sensitive data out there.
- Updated comment in logrotate script, thanks to discussion in
  Sisyphus mailing list:
  http://www.altlinux.ru/pipermail/sisyphus/2003-February/039434.html

* Tue Jan 28 2003 Dmitry V. Levin <ldv@altlinux.org> 3.23.55-alt1
- Updated to 3.23.55.
- Applied docs build fixes from Lenz Grimmer.

* Fri Dec 13 2002 Dmitry V. Levin <ldv@altlinux.org> 3.23.54-alt2
- mysqlbug: fixed contact email address.

* Thu Dec 12 2002 Dmitry V. Levin <ldv@altlinux.org> 3.23.54-alt1
- Updated to 3.23.54.
- Updated chroot patch to new version.
- Added reservedwords.texi (lost in new version).
- Updated interpackage dependencies.
- Adjusted perl dependencies.

* Tue Dec 03 2002 Stanislav Ievlev <inger@altlinux.ru> 3.23.53-alt2
- added server-perl subpackage, to reduce deps on perl of server

* Tue Oct 15 2002 Dmitry V. Levin <ldv@altlinux.org> 3.23.53-alt1
- 3.23.53
- Better debugging support.

* Mon Sep 16 2002 Dmitry V. Levin <ldv@altlinux.org> 3.23.52-alt1
- 3.23.52
- Ensure tzset(3) is called before chroot(2).
- Removed %_sysconfdir/localtime from %ROOT chroot.
- Use subst instead of perl for text substitution.
- Linked with readline-4.3.
- Built with gcc-3.2.

* Wed Jul 03 2002 Dmitry V. Levin <ldv@altlinux.org> 3.23.51-alt2
- Patched to link with libtinfo.

* Fri Jun 14 2002 Dmitry V. Levin <ldv@altlinux.org> 3.23.51-alt1
- 3.23.51
- Fixed typo in safe_mysqld.
- Removed aggressive optimization.

* Sat Apr 27 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.23.50-alt1
- 3.23.50

* Wed Apr 17 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.23.49-alt5
- Fixed recent fix.

* Tue Apr 16 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.23.49-alt4
- Updated chroot (fixed permissions, added NIS/NIS+ support).

* Mon Apr 08 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.23.49-alt3
- Added my_dir.h to libMySQL-devel (#0000701).

* Thu Feb 21 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.23.49-alt2
- Added %ROOT/dev removal from existing configurations.
- Dropped mysql.chroot.log script (unneeded anymore).

* Wed Feb 20 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.23.49-alt1
- 3.23.49.
- Removed /dev from %ROOT.
- Fixed server %%post/%%preun scripts (#0000324).

* Fri Jan 04 2002 Dmitry V. Levin <ldv@alt-linux.org> 3.23.47-alt1
- 3.23.47.

* Thu Dec 13 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.23.46-alt2
- Made gif2png conversion configurable.
- Automatically regenerated buildrequires.

* Mon Dec 03 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.23.46-alt1
- 3.23.46

* Mon Nov 26 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.23.45-alt1
- 3.23.45
- Fixed relocation of libmysqlclient* libraries (#0000145).
- Split html documentation (#0000179).
- Added png pictures to html documentation subpackage.

* Sun Nov 04 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.23.44-alt1
- 3.23.44

* Wed Oct 10 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.23.43-alt1
- 3.23.43
- Patched scripts in MySQL-bench to make them functional (mdk).

* Fri Sep 21 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.23.42-alt1
- 3.23.42
- Updated interpackage dependencies.
- Built with internal db-3.2.9a.

* Fri Apr 27 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.23.33-ipl8mdk
- Fixed mysqld_wrapper to handle server shutdown correctly.
- Relocated mysql_install_db from %_bindir to %_sbindir/
- Updated mysql_install_db to work with chrooted environments.

* Thu Apr 26 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.23.33-ipl7mdk
- Fixed (finally?) server %%postin script to handle recent database move.

* Wed Apr 25 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.23.33-ipl6mdk
- Fixed (again) server %%postin script to handle recent database move.
- Updated PreReqs for server subpackage.

* Tue Apr 24 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.23.33-ipl5mdk
- Updated %%postin script to handle recent database move.

* Sat Apr 21 2001 Alexander Bokovoy <ab@avilink.net> 3.23.33-ipl4mdk
- Fixed bug in datadir handling for chrooted environments.
- MySQL databases moved to $chrootdir/db/
- libMySQL-devel has been transformed to libMySQL-devel and libMySQL-devel-static
- mysql_config has been changed to reflect libMySQL-devel splitting:
    + it returns $libs set to shared ones only when libMySQL-devel-static not installed

* Tue Feb 27 2001 Dmitry V. Levin <ldv@fandra.org> 3.23.33-ipl3mdk
- Fixed dependencies for server subpackage (added PreReqs).
- Moved %_bindir/my_print_defaults utility back to client subpackage.
- Moved texinfo documentation back to client subpackage.
- Fixed %%post/%%preun scripts for proper texinfo documentation (un)installation.

* Sat Feb 24 2001 Alexander Bokovoy <ab@avilink.net> 3.23.33-ipl2mdk
- Proper distribution of utilites along packages
- Fixed texinfo documentation
- Fixed dependencies

* Thu Feb 15 2001 Dmitry V. Levin <ldv@fandra.org> 3.23.33-ipl1mdk
- 3.23.33
- Rewritten startup scripts.
- Ported to new chrooted scheme.
- Changed address for bug reports to devel@alt-linux.org.

* Fri Feb 09 2001 Dmitry V. Levin <ldv@fandra.org> 3.23.32-ipl6mdk
- Libification.
- Fixed texinfo documentation.
- Client: added readline expansion for all symbols.

* Thu Feb 01 2001 Alexander Bokovoy <ab@avilink.net> 3.23.32-ipl5mdk
- New version with correct db3

* Sat Dec 30 2000 Alexander Bokovoy <ab@avilink.net> 3.23.29-ipl4mdk
- MySQL-devel depends on MySQL-shared, not MySQL-client
- Syntax error in mysql_install_db fixed

* Sun Dec 24 2000 Alexander Bokovoy <ab@avilink.net> 3.23.29-ipl3mdk
- Update to 3.23.29
- Rebuild with db3-3.2.3e

* Sun Dec 17 2000 Alexander Bokovoy <ab@avilink.net> 3.23.28-ipl2mdk
- Duplication of files in MySQL/MySQL-Client fixed
- mysql_config moved to MySQL-shared
- Various programs from MySQL package require DBI and DBD::mysql perl modules,
  dependencies fixed
- mysqlbug redirects bug reports to devel@linux.iplabs.ru mailing list
- MyISAM RAID type enabled by default

* Sat Dec 16 2000 Alexander Bokovoy <ab@avilink.net> 3.23.28-ipl1mdk
- Updated to 3.23.28
- SPEC file cleaned and uses now IPL rules
- Russian translations added
- Transactions support with BDB tables
- Bench package now requires perl-DBD-mysql instead of perl-Mysql
- Init script has new status command which displays pids of mysqld processes
- Various C++ fixes against g++ 2.96

* Tue Nov 16 2000 Mikhail Zabaluev <mookid@sigent.ru> 3.23.27-1mdk_mhz
- Updated to 3.23.27
- --with-extra-charsets=all, because we need Cyrillic
- made sure that readline is external
- macroized install-info
- mandrakized init script
- custom logrotate config to rotate *.err logs

* Sat Sep 02 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.23-1mdk
- Updated to 3.23.23 to correct php segfaults
- Added separate libmysql_r directory; now both a threaded
  and non-threaded library is shipped.

* Tue Aug 09 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.22-2mdk
- Put libmysqlclient.so in devel package

* Mon Aug 07 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.22-1mdk
- Updated to 3.23.22
  (this is a beta version, but starting from 3.23.19, the license is
   GPL, so we prefer the beta to the non-GPL stable tree)
- Macroize
- Merged with the spec from David Axmark <davida@mysql.com>
  :Added the support-files/my-example.cnf to the docs directory.
  :Removed devel dependency on base since it is about client
   development.
  :The --enable-assembler switch is now automatically disables on
   platforms there assembler code is unavailable. This should allow
   building this RPM on non i386 systems.

* Tue May 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.22.32-6mdk
- Recompile with egcs on alpha.

* Tue Apr 18 2000 Pixel <pixel@mandrakesoft.com> 3.22.32-5mdk
- disable starting of mysql while in install

* Thu Apr 06 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.22.32-4mdk
- fix bench perms

* Thu Apr 06 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.22.32-3mdk
- cleaned spec file

* Mon Apr 03 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.22.32-2mdk
- new group

* Mon Feb 27 2000 Jean-Michel Dault <jmdault@netrevolution.com> 3.22.32-1mdk
- updated to 3.22.32 - security updates

* Wed Jan 19 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 3.22.30

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- final cleanup for Mandrake 7

* Mon Jan 3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 3.22.29

* Wed Dec 31 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- rebuilt for Mandrake 7.0

* Sat Dec 12 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 3.22.27

* Wed Sep 1 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- put the shared libs in separate package
- fixed dependancies

* Thu Aug 19 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- added fr locale
- Mandrake adaptations
- Solaris adaptations

* Mon Feb 22 1999 David Axmark <david@detron.se>
- Removed unportable cc switches from the spec file. The defaults can
  now be overridden with environment variables. This feature is used
  to compile the official RPM with optimal (but compiler version
  specific) switches.
- Removed the repetitive description parts for the sub rpms. Maybe add
  again if RPM gets a multiline macro capability.
- Added support for a pt_BR translation. Translation contributed by
  Jorge Godoy <jorge@bestway.com.br>.

* Wed Nov 4 1998 David Axmark <david@detron.se>
- A lot of changes in all the rpm and install scripts. This may even
  be a working RPM :-)

* Sun Aug 16 1998 David Axmark <david@detron.se>
- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference
  Manual.  Only RPM specific changes will be documented here.
